# ==== check_mach.py :
# --- Debut: 2023-02-10
"""
 objectif: (3eme objectif)
=========================
- Un modele en mode graphique
- Tout se fait par des commandes:
  l'ajout/suppression d'un drum, le changement d'UKW, ...
- Le logiciel est fait en plusieurs parties:
  * check_mach.py : la bibliotheque (CE PROGRAMME!)
  * check_mach_tui.py : l'interface texte
  * check_mach_gui.py : l'interface graphique
"""

import sys
import eniM4_none as enigma
import string
import getopt
import re
import glob
ALPHA = string.ascii_uppercase

# ===================================
def car_to_num(car):
    """ Translate a letter to a number (A->0, B->1, ...) """
    return ALPHA.find(car)
# ===================================
def is_maj(car):
    """ is a letter (A,B,...,Z) ? """
    if string.ascii_uppercase.find(car) == -1: 
        return False
    else:
        return True
# ===================================
def grund2str( grund ):
    if grund is None:
        return "-"
    else:
        return grund
# ===================================
def avance(e, pos):
    index = "XSIF".find(pos)
    if e.getGrund(pos) is None:
        return
    car_index = e.getGrund(pos)
    letter_index = ALPHA.find(car_index)
    new_car   = ALPHA[ (letter_index + 1)%26 ]
    e.setGrund(pos, new_car)
# ===================================
def recule(e, pos):
    index = "XSIF".find(pos)
    if e.getGrund(pos) is None:
        return
    car_index = e.getGrund(pos)
    letter_index = ALPHA.find(car_index)
    new_car   = ALPHA[ (letter_index + 25)%26 ]
    e.setGrund(pos, new_car)
# ===================================
def removeDrum(e, pos):
    if pos == "U":
        e.removeUKW()
    else:
        e.removeDrum(pos)
# ===================================
def addDrum(e, pos, drum):
    if pos == "U":
        e.setUKW(drum)
    else:
        e.setDrum(pos, drum)
# ===================================
def chiffre(e, car):
    if is_maj(car) and e.is_circuit_closed():        
        chiffre = e.encode(car)
        return chiffre

# ===================================
def lstDrum():
    fics = glob.glob('rotors/*.rot')
    lst = []
    for fic in fics:
        m = re.search('.*/(.*)\.rot', fic)
        lst.append( m.group(1) )
    return lst    
#==============================================
# ------------> Debut Progamme <-----
if __name__ == "__main__":
    print("===== TEST =======")
    e = enigma.Enigma()
    e.removeUKW()
    e.removeUKW()
    e.setUKW("B")
    e.setDrum("X","iden")
    e.setDrum("S","iden")
    e.setDrum("I","iden")
    e.setDrum("F","iden")
    print( chiffre(e, 'K') )
