#!/usr/bin/python3
# check_mach_gui.py
# checking_machine in graphical mode
# === 14/02/2023: A faire:
# - aide via une fenetre ???
# - ajouter à l'aide: l'indication du role du drum "straight"

import tkinter as tk
import tkinter.font as TF
import string
import math
import sys
import eniM4_none as enigma
import check_mach as CM
import tkinter.messagebox as MSG
import os
import platform
import subprocess

#==========================================================
def info():
    msg = "U:%s, X:%s-S:%s-I:%s-F:%s\n" % (str(SLOTS["U"]), str(SLOTS["X"]),
        str(SLOTS["S"]), str(SLOTS["I"]), str(SLOTS["F"]))
    msg += "Grund: %s-%s-%s-%s\n" % (
        e.getGrund("X"),e.getGrund("S"),e.getGrund("I"),e.getGrund("F"))
    msg += "Is Electical Circuit Closed? %r\n" % (e.is_circuit_closed() )
    if e.getGrund("X") is None:
        enigma_type = "???"
    elif e.getDrum("X") == "straight":
        enigma_type = "M3"
    else:
        enigma_type = "M4"
    msg += "Enigma Type: %s\n" % (enigma_type)
    msg += "Mode Debug:%r\n" % (DEBUG)
    top.option_add('*Dialog.msg.font',TF.Font(family='times',size=12,weight='normal'))
    MSG.showinfo(title='Information',message=msg)
    top.option_clear()
#==========================================================
def manual():
    aide_file = "manual.pdf"
    if   platform.system() == "Windows":
        os.startfile( aide_file )
    elif platform.system() == "Linux":
        os.system("gio open "+aide_file+" 2>/dev/null &")
    else:
        showinfo('Help',"Read the file " + aide_file)
#==========================================================
def quitter():
    sys.exit()
#==========================================================
def change_debug():
    global DEBUG
    if MODE_DEBUG.get():
        DEBUG = True
    else:
        DEBUG = False
#==========================================================
def change_ukw():
    CM.removeDrum(e, "U")
    CM.addDrum(e, "U", THE_UKW.get() )
    SLOTS["U"] = THE_UKW.get()
    change_label("U")
#==========================================================
def dessine_rotor(position):
    (x1,y1) = coord_rotor[position]
    x2 = x1 + 100
    y2 = y1 + 100
    if img_rot[position] is not None:
        ecran.delete(img_rot[position])
    if txt_rot[position] is not None:
        ecran.delete(txt_rot[position])
    if SLOTS[position] is None:
        img_rot[position] = ecran.create_oval(x1,y1,x2,y2,fill="pink")
    else:
        name_rot = SLOTS[position]
        color = COLOR_ROT[name_rot]
        lettre = 'A'
        img_rot[position] = ecran.create_oval(x1,y1,x2,y2,fill=color)
        fg = "red" if color in ["green","cyan","yellow","LightGray","maroon","blue","black"] else "green"
        txt_rot[position] = ecran.create_text(x1+50,y1+50,text=lettre,
            font=['courrier',36,'bold'],fill=fg)    
    change_label(position)
#==========================================================
def dessine_txt_rot(position):
    if SLOTS[position] is None:
        return
    (x1,y1) = coord_rotor[position]
    if txt_rot[position] is not None:
        ecran.delete(txt_rot[position])
    lettre = e.getGrund(position)
    name_rot = SLOTS[position]
    color = COLOR_ROT[name_rot]
    fg = "red" if color in ["green","cyan","yellow","LightGray","maroon","blue","black"] else "green"
    txt_rot[position] = ecran.create_text(x1+50,y1+50,text=lettre,
        font=['courrier',36,'bold'],fill=fg)    
#==========================================================
def dessine_lampes(lettre, etat):
    (x1,y1) = coord_lampes[lettre]
    x2 = x1 + 20
    y2 = y1 + 20
    fg = "black" if etat == "allumee" else "white"
    ecran.create_oval(x1,y1,x2,y2,fill="grey")
    ecran.create_text(x1+10,y1+10,text=lettre,
        font = ['courrier',12,'bold'],fill=fg)
#==========================================================
def dessine_touches(lettre, etat):
    (x1,y1) = coord_touches[lettre]
    x2 = x1 + 20
    y2 = y1 + 20
    fg = "green" if etat == "enfoncee" else "grey"
    ecran.create_oval(x1,y1,x2,y2,fill="black")
    ecran.create_text(x1+10,y1+10,text=lettre,
        font = ['courrier',12,'bold'],fill=fg)
#==========================================================
def appuie_touche(evt, lettre=None):
    global une_touche_enfoncee, lettre_clair, lettre_crypto, CHIFFREMENT
    if evt != "j":
        lettre = evt.char
    if DEBUG:
        print(">>appuie_touche:", evt, lettre)
    val_ascii = ord(lettre)
    if (val_ascii >= 97):
        lettre = chr(val_ascii-32)
    if une_touche_enfoncee:
        return
    if lettre in coord_touches:
        lettre_clair = lettre
        dessine_touches(lettre_clair,"enfoncee")
        x = ord(lettre_clair) - 65
        lettre_crypto = CM.chiffre(e, lettre_clair)
        if lettre_crypto is not None:
            dessine_lampes(lettre_crypto,"allumee")
            CHIFFREMENT = True
        else:
            CHIFFREMENT = False
        une_touche_enfoncee = True   
        if DEBUG:
            print("<<",lettre_clair,lettre_crypto,une_touche_enfoncee)
#==========================================================
def distance(x1,x2,y1,y2):
    return math.sqrt((x2-x1)**2+(y2-y1)**2)
#==========================================================
def change_label(pos):
    txt = SLOTS[pos]
    if txt is None:
        txt = "       "
    ecran.itemconfig( labels_rot[pos], text = txt )
#==========================================================
def relache_touche(evt=None):
    global une_touche_enfoncee, CHIFFREMENT
    if not une_touche_enfoncee:
        return
    une_touche_enfoncee = False
    dessine_touches(lettre_clair,"relachee")
    if CHIFFREMENT:
        dessine_lampes(lettre_crypto,"eteinte")
        CHIFFREMENT = False
#==========================================================
def relache_souris(evt):
    relache_touche()
#==========================================================
def appuie_souris(evt):
    global ANCIEN_ROT, NEW_ROT
    x1 = evt.x 
    y1 = evt.y

    # --- a-t-on appuye sur un rotor ?
    for position in ROTS:
        (x2,y2) = coord_rotor[position]
        (x2,y2) = (x2+50,y2+50)
        d = distance(x1,x2,y1,y2)
        if ( d < 50 ):
            if DEBUG:
                print(">>>appuie_rotor:", position)
            if SELECT_ROT.get() == 1:
                # --- We add or remove drum
                if DEBUG:
                    print("--- add / remove drum", NAME_ROT[ ANCIEN_ROT ])
                if NEW_ROT == 0:
                    SLOTS[position] = None
                    CM.removeDrum(e, position)
                else:
                    if SLOTS[position] is None:
                        SLOTS[position] = NAME_ROT[NEW_ROT]
                        CM.addDrum(e, position, NAME_ROT[NEW_ROT])
                dessine_rotor(position)
            else:
                # --- We step drum
                if SLOTS[position] is None:
                    return
                if x1 > x2:
                    if DEBUG: print("AVANCE ROTOR",)
                    CM.avance(e, position)
                else:
                    if DEBUG: print("RECULE ROTOR",)
                    CM.recule(e, position)
                dessine_txt_rot(position)
                return
    # --- a-t-on appuye sur une touche du clavier?
    for i in range(26):
        (x2,y2) = (i*20+25, 210)
        d = distance(x1,x2,y1,y2)
        if ( d < 10) :
            appuie_touche("j", chr(i+65))
            if DEBUG: print("---> appui touche ", i )
            return

    # --- a-t-on choisi un rotor (zone du bas)
    if SELECT_ROT.get() == 0:
        return
    for i in range(12):
        if i < 9:
            (x2,y2) = (i*60+40, 310)
        else:
            (x2,y2) = ((i-3)*60+40, 265)
        d = distance(x1,x2,y1,y2)
        if d < 10:
            if DEBUG: print(">>>dessine cadre", i)
            if ANCIEN_ROT != -1:
                if DEBUG: print("--- supprime cadre", ANCIEN_ROT)
                if ANCIEN_ROT < 9:
                    ecran.create_rectangle(60*ANCIEN_ROT+18,298,60*ANCIEN_ROT+62,322,
                        outline='white')
                else:
                    ecran.create_rectangle(60*(ANCIEN_ROT-3)+18,253,
                        60*(ANCIEN_ROT-3)+62,277,outline='white')
                ANCIEN_ROT = -1
            if DEBUG:
                print("--- ajoute cadre", i, " ancien cadre:", ANCIEN_ROT)
            if i < 9:
                ecran.create_rectangle(60*i+18,298,60*i+62,322)
            else:
                ecran.create_rectangle(60*(i-3)+18,253,60*(i-3)+62,277)
            ANCIEN_ROT = i
            NEW_ROT = i
#==========================================================

# 0. Initials settings
ALPHA = string.ascii_uppercase
ROTS  = ['X', 'S', 'I', 'F']
DATA = [
    [ROTS[0], 30, 40],
    [ROTS[1],160, 40],
    [ROTS[2],290, 40],
    [ROTS[3],420, 40]
]
SLOTS = {'X':None, 'S':None, 'I':None, 'F':None, 'U':"B"}
COLORS = ['white','red','maroon','green','yellow','cyan','blue','black',
    'LightGray','white','white','white']
NAME_ROT = ['Empty','I','II','III','IV','V','VI','VII','VIII',
    'straight','beta','gamma']
COLOR_ROT = dict(zip(NAME_ROT,COLORS))
une_touche_enfoncee = False
lettre_clair = None
lettre_crypto = None
ANCIEN_ROT = -1
NEW_ROT = -1
CHIFFREMENT = False
e = enigma.Enigma()
e.setUKW("B")

# 1. We create root window and canvas (which contains all graphical objects)
top = tk.Tk()
SELECT_ROT = tk.IntVar()
SELECT_ROT.set(True)
DEBUG = False
MODE_DEBUG = tk.BooleanVar()
THE_UKW    = tk.StringVar()
THE_UKW.set("B")
MODE_DEBUG.set(False)
ecran = tk.Canvas(top, width=550, heigh=350)
ecran.pack()

# 2 We create the labels for name of drums
labels_rot = {}
labels_rot["X"] = ecran.create_text( 80, 20,font=['courrier',12,'normal'], fill="black")
labels_rot["S"] = ecran.create_text(210, 20,font=['courrier',12,'normal'], fill="black")
labels_rot["I"] = ecran.create_text(340, 20,font=['courrier',12,'normal'], fill="black")
labels_rot["F"] = ecran.create_text(470, 20,font=['courrier',12,'normal'], fill="black")
labels_rot["U"] = ecran.create_text( 80,240,font=['courrier',12,'normal'], fill="black")

# 3. We create the drums
coord_rotor = {}
img_rot = {}
txt_rot = {}
for i in range(4):
    coord_rotor[DATA[i][0]] = [DATA[i][1], DATA[i][2]]
for position in coord_rotor.keys():
    img_rot[position] = None
    txt_rot[position] = None
    dessine_rotor(position)
change_label("U")

# 4. We create keyboard
coord_touches = {}
for i in ALPHA:
    x = 20 * (ord(i)-65) + 15
    y = 200
    coord_touches[i] = [x, y]
for i in ALPHA:
    dessine_touches(i, "relachee")

# 5. We create lamps
coord_lampes = {}
for i in ALPHA:
    x = 20 * (ord(i)-65) + 15
    y = 170
    coord_lampes[i] = [x, y]
for i in ALPHA:
    dessine_lampes(i, "eteinte")
    
# 6. We create bottom zone
ecran.create_rectangle(0,250,550,350, fill="white")
for i in range(9):
    ecran.create_rectangle(60*i+20,300,60*i+60,320,fill=COLORS[i])
for i in range(9):
    col_car = "red" if i == 0 else "black"
    ecran.create_text(60*i+30,335,text=NAME_ROT[i],
        font=['courrier',12,'normal'],fill=col_car)
for i in range(9,12):
    ecran.create_rectangle(60*(i-3)+20,255,60*(i-3)+60,275,fill=COLORS[i])
for i in range(9,12):
    ecran.create_text(60*(i-3)+30,285, text=NAME_ROT[i],
        font=['courrier',12,'normal'],fill='black')

# 7. Add the mode zone
mode_zone = tk.Frame(ecran, bg='gray100')
ecran.create_window(0,250,window=mode_zone,anchor="nw")
button = tk.Checkbutton(mode_zone, text=" Add/Remove a Drum (or Step a Drum)",
    variable = SELECT_ROT)
button.pack()

# 8. Add a Menu
the_ukws = ['A','B','C','Thin-B','Thin-C']
menu_principal = tk.Menu(top)
menu_file = tk.Menu(menu_principal, tearoff=0)
menu_file.add_command(label="Exit", command=quitter)
menu_ukw  = tk.Menu(menu_principal, tearoff=0)
for ukw in the_ukws:
    menu_ukw.add_radiobutton(label=ukw, value=ukw, 
        variable=THE_UKW, command=change_ukw)
menu_help  = tk.Menu(menu_principal, tearoff=0)
menu_help.add_command(label="Manual", command=manual)
menu_help.add_checkbutton(label="Debug",variable=MODE_DEBUG, command=change_debug)
menu_help.add_command(label="Info",command=info)
menu_principal.add_cascade(label="file", menu=menu_file)
menu_principal.add_cascade(label="ukw",  menu=menu_ukw)
menu_principal.add_cascade(label="help", menu=menu_help)
top.config(menu=menu_principal)

# 9. We set evenments binding and we wait for evenements
top.bind("<Button>", appuie_souris)
top.bind("<ButtonRelease>", relache_souris)
top.bind("<KeyPress>", appuie_touche)
top.bind("<KeyRelease>", relache_touche)

top.mainloop()

