# ==== check_mach_tui.py :
# --- Debut: 2023-02-10
"""
 objectif: (2.5eme objectif)
=========================
- Un modele en mode texte
- Tout se fait par des commandes:
  (les memes qu'en mode graphique)
"""

import sys
import eniM4_none as enigma
import string
import getopt
import check_mach as CM
ALPHA = string.ascii_uppercase

# ===================================
def car_to_num(car):
    """ Translate a letter to a number (A->0, B->1, ...) """
    return ALPHA.find(car)
# ===================================
def is_maj(car):
    """ is a letter (A,B,...,Z) ? """
    if string.ascii_uppercase.find(car) == -1: 
        return False
    else:
        return True
# ===================================
def grund2str( grund ):
    if grund is None:
        return "-"
    else:
        return grund
# ===================================
def affiche_pos():
    if e.is_circuit_closed():
        print("Closed circuit", end="")
    else:
        print("Open circuit  ", end="")
    print(", UKW,Thin,Left,Middle,Right:", end=" ")
    print(  e.getUKW(), end=", " )
    print(  e.getDrum("X"), 
            e.getDrum("S"),
            e.getDrum("I"),
            e.getDrum("F"), end=", "
    )
    GRUND = ""
    GRUND += grund2str( e.getGrund("X") )
    GRUND += grund2str( e.getGrund("S") )
    GRUND += grund2str( e.getGrund("I") )
    GRUND += grund2str( e.getGrund("F") )
    print( "GRUND: ", GRUND )
    print()
# ===================================
# ------------> Debut Progamme <-----
DEBUG = False
#==============================================
# The Enigma
e = enigma.Enigma(DEBUG)
e.setUKW("B")
e.setDrum("X","iden")
e.setDrum("S","I")
e.setDrum("I","II")
e.setDrum("F","III")
#======= Big loop 
old_cmd = "HLP"
while True:
    affiche_pos()
    try:
        ch = input("Command [HLP == Help] ? ")
    except EOFError:
        print("EOF")
        break
    if len(ch) == 1:
        ch = ch.upper()
        if ch in ALPHA:
            lettre = CM.chiffre(e, ch)
            print(ch, " -> ", lettre)
        continue
    if len(ch) > 2:
        cmd = ch[:3].upper()
        if len(ch) > 3:
            suite = ch[3:]
        else:
            suite = ""
    else:
        cmd = old_cmd

    if   cmd == "HLP":
        print(">> To validate without command repeat the last command")
        print(">> The 'iden' in X position, permit to check 3 rotors Enigma")
        print("x        Cipher the letter 'x'")
        print("HLP:     Help")
        print("EXT:     Exit")
        print("LST:     List available drums")
        print("ADD:     Add a drum [ex: 'add:X:III']")
        print(" Remark: the slot must be empty [use RMV command first]")
        print("RMV:     remove a drum [ex: 'rmv:X']")
        print(" drum ::= U | X | S | I | F (ukw,thin,left,middle,right)")
        print("          Ukw, X, Slow, Intermediate, Fast")
        print("AVN:     Drum: Step forward [ex: 'avn:X']")
        print("RCL:     Drum: Step back    [ex: 'rcl:X']")
    elif cmd == "EXT":
        break
    elif cmd == "ADD":
        if len(suite) > 3:
            pos = suite[1]
            drum = suite[3:]
            try:
                CM.addDrum(e, pos, drum)
            except FileNotFoundError:
                print("The drum", drum, "was not found")
    elif cmd == "RMV":
        if len(suite) == 2:
            pos = suite[1]           
            CM.removeDrum(e, pos)
    elif cmd == "AVN":
        if len(suite) == 2:
            pos = suite[1]
            CM.avance(e, pos)
    elif cmd == "RCL":
        if len(suite) == 2:
            pos = suite[1]
            CM.recule(e, pos)
    elif cmd == "LST":
        print( CM.lstDrum() )
    old_cmd = cmd
