# eniM4_none.py : modele Enigma M4
# modele special pour la "checking_machine"
# - pas de stecker
# - pas de stepping (carry)
# - possiblilite de ne rien configurer (pas de rotor)

import string

def C2L(car):
    return string.ascii_uppercase.index(car)

def L2C(lettre):
    return  string.ascii_uppercase[lettre]

class Rotor:
    def __init__(self,nomDuRotor):
        fic = open("rotors/"+nomDuRotor+".rot","r")
        PI = fic.readline()
        # print "===> ", PI
        les_notchs = fic.readline()
        les_notchs = les_notchs.strip()
        # print "===> ", les_notchs, " lg: ", len(les_notchs)
        self.decal = list(range(26))
        self.decal_inv = list(range(26))
        self.Notchs = list(range(26))
        self.ring = 0
        self.index = 0
        tampon = list(range(26))
        for i in range(26):
            indice = C2L(PI[i])
            self.decal[i] = ( indice - i + 26 ) % 26
        for i in range(26):
            tampon[ C2L( PI[i] ) ] = i
        for i in range(26):
            self.decal_inv[i] = ( tampon[i] - i + 26 ) % 26
        for i in range(26):
            self.Notchs[i] = 0
        for i in range(len(les_notchs)):
            self.Notchs[ C2L( les_notchs[i] ) ] = 1
        self.nom = nomDuRotor
        #print nomDuRotor
        #print self.decal
        #print self.decal_inv

    def setGrund(self,x):
        self.index = x
    def getGrund(self):
        return self.index
    def isCarry(self):
        if ( self.Notchs[self.index]): 
            return 1
        else: 
            return 0
    def setRing(self, x):
        self.ring = x
    def avance(self):
        self.index = (self.index + 1) % 26
    def recule(self):
        self.index = (self.index - 1 + 26) % 26
    def chiffre(self,x):
        return (x + self.decal[ (x + self.index - self.ring + 26)%26 ]) % 26
    def dechiffre(self,x):
        return (x + self.decal_inv[ (x+ self.index - self.ring + 26)%26 ]) % 26

class Enigma:
    def __init__(self, debuging=0):
        self.Debug = debuging
        self.compteur = 0
        self.drum_names = ["X","S","I","F"]
        # X==thin, S==left, I==middle, F==right
        self.rotor_right = None
        self.rotor_middle= None
        self.rotor_left  = None
        self.rotor_thin =  None
        self.rotor_reflec= None
        self.closed_circuit = False

    def is_circuit_closed(self):
        if  self.rotor_right is None or \
            self.rotor_middle is None or \
            self.rotor_left is None or \
            self.rotor_thin is None or \
            self.rotor_reflec is None :
            self.closed_circuit = False
            return False
        else:
            self.closed_circuit = True
            return True

    def setUKW(self, drum):
        if self.rotor_reflec is None:
            self.rotor_reflec = Rotor(drum)

    def getUKW(self):
        if self.rotor_reflec is not None:    
            return self.rotor_reflec.nom
        else:
            return " - "

    def removeUKW(self):
        if self.rotor_reflec is not None:
            self.rotor_reflec = None
        
    def setDrum(self, pos, drum):
        # peut generer une exception si le rotor n'existe pas
        if   pos == "X" and self.rotor_thin is None:
            self.rotor_thin = Rotor(drum)
            self.is_circuit_closed()
        elif pos == "S" and self.rotor_left is None:    
            self.rotor_left = Rotor(drum)
            self.is_circuit_closed()
        elif pos == "I" and self.rotor_middle is None:    
            self.rotor_middle = Rotor(drum)
            self.is_circuit_closed()
        elif pos == "F" and self.rotor_right is None:    
            self.rotor_right = Rotor(drum)
            self.is_circuit_closed()
        else:
            return

    def getDrum(self, pos):
        if   pos == "X" and self.rotor_thin is not None:
            return self.rotor_thin.nom 
        elif pos == "S" and self.rotor_left is not None:    
            return self.rotor_left.nom
        elif pos == "I" and self.rotor_middle is not None:    
            return self.rotor_middle.nom
        elif pos == "F" and self.rotor_right is not None:    
            return self.rotor_right.nom
        else:
            return " - "

    def removeDrum(self, pos):
        if   pos == "X" and self.rotor_thin is not None:
            self.rotor_thin = None
            self.is_circuit_closed()
        elif pos == "S" and self.rotor_left is not None:    
            self.rotor_left = None
            self.is_circuit_closed()
        elif pos == "I" and self.rotor_middle is not None:    
            self.rotor_middle = None
            self.is_circuit_closed()
        elif pos == "F" and self.rotor_right is not None:    
            self.rotor_right = None
            self.is_circuit_closed()
        else:
            return

    def setGrund(self, pos, grund):
        if   pos == "X" and self.rotor_thin is not None:
            self.rotor_thin.setGrund(C2L(grund))
        elif pos == "S" and self.rotor_left is not None:    
            self.rotor_left.setGrund(C2L(grund))
        elif pos == "I" and self.rotor_middle is not None:    
            self.rotor_middle.setGrund(C2L(grund))
        elif pos == "F" and self.rotor_right is not None:    
            self.rotor_right.setGrund(C2L(grund))
        else:
            return

    def getGrund(self, pos):
        if   pos == "X" and self.rotor_thin is not None:
            return L2C(self.rotor_thin.getGrund())
        elif pos == "S" and self.rotor_left is not None:    
            return L2C(self.rotor_left.getGrund())
        elif pos == "I" and self.rotor_middle is not None:    
            return L2C(self.rotor_middle.getGrund())
        elif pos == "F" and self.rotor_right is not None:    
            return L2C(self.rotor_right.getGrund())
        else:
            return None

    def encode(self, lettre):
        if not self.is_circuit_closed():
            return None
        lettre = C2L(lettre)
        self.compteur = self.compteur + 1
        lettre = self.rotor_right.chiffre(lettre)
        lettre = self.rotor_middle.chiffre(lettre)
        lettre = self.rotor_left.chiffre(lettre)
        lettre = self.rotor_thin.chiffre(lettre)
        lettre = self.rotor_reflec.chiffre(lettre)
        lettre = self.rotor_thin.dechiffre(lettre)
        lettre = self.rotor_left.dechiffre(lettre)
        lettre = self.rotor_middle.dechiffre(lettre)
        lettre = self.rotor_right.dechiffre(lettre)
        return L2C(lettre)

    def decode(self,car):
        return encode( self, car)

